<?php
error_reporting(E_ALL);
/*
TuxBoard forum script
Copyright (C) 2013  Colin Murphy

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

session_start();
require_once("config.php");
require_once("bbcode.php");
if ($_SESSION["tb_username"] and $_SESSION["tb_password"]) {
	if (file_exists($config["userdata"] . $_SESSION["tb_username"] . ".php")) {
		# User exists. Check if password is correct.
		include($config["userdata"] . $_SESSION["tb_username"] . ".php");
		if ($tbPassword == htmlentities(stripslashes($_SESSION["tb_password"]), ENT_QUOTES)) {
			# Password is correct.

			$action = htmlentities(stripslashes($_GET["action"]), ENT_QUOTES);
			if (!file_exists($config["userdata"] . $_SESSION["tb_username"] . ".admin")) {header("Location: index.php"); exit;}
			if (!$action) { $action = "main"; }
			switch ($action) {
			#------------ main page
			case "main":
				$ptitle = "Administration panel - " . $config["title"];
				include($config["themes"] . $config["theme"] . "/header.html");
				?>
					<h2>Forum Administration</h2>
					<h3>Forums</h3>
					<p>&nbsp;&bull; <a href="adm.php?action=forums">Manage forums</a></p>
					<h3>Announcements</h3>
					<p>&nbsp;&bull; <a href="adm.php?action=announce">Announcements</a></p>
					<p>&nbsp;&bull; <a href="adm.php?action=infobox">Forum information box</a></p>
					<h3>Users</h3>
					<p>&nbsp;&bull; <a href="adm.php?action=mkadmin">Add admin rights to user</a></p>
					<p>&nbsp;&bull; <a href="adm.php?action=rmadmin">Remove admin rights from user</a></p>
					<!--<p>&nbsp;&bull; <a href="adm.php?action=deluser">Delete user</a></p>-->
					<p>&nbsp;&bull; <a href="adm.php?action=chrank">Change user's rank</a></p>
					<p>&nbsp;&bull; <a href="adm.php?action=chcolor">Change user's color</a></p>
					<h3>Logs</h3>
					<p>&nbsp;&bull; <a href="adm.php?action=logs">View logs</a></p>
				<?php
				include($config["themes"] . $config["theme"] . "/footer.html");
			break;

			#----------- categories
			case "forums":
				$ptitle = "Forums - Administration panel - " . $config["title"];
				include($config["themes"] . $config["theme"] . "/header.html");
				?>
					<h2><a href="adm.php">ADM:</a> Forums</h2>
					<h3>Edit a forum</h3>
<?php					
				foreach (glob($config["datadir"] . "*") as $cat) {
					$title = file_get_contents("$cat/title.txt"); # forum title
					$description = file_get_contents("$cat/description.txt"); # Forum description
					$cat = str_replace($config["datadir"], "", $cat); # get rid of $config["datadir"]'s name
echo "<form action=\"adm.php?action=editforum&amp;id=$cat\" method=\"post\">
<fieldset>
	<legend>$title</legend>
	<table>
		<tr><td><strong>Name:</strong></td><td><input type=\"text\" name=\"title\" value=\"$title\"></td></tr>
		<tr><td><strong>Description:</strong></td><td><textarea rows=\"5\" cols=\"30\" name=\"description\">$description</textarea></td></tr>
		<tr><td>&nbsp;</td><td><input type=\"submit\" value=\"Edit forum\"></td></tr>
	</table>
</fieldset>
</form>";
}

?>
					<!-- add new category form-->
					<hr>
					<h3>Add new forum</h3>
					<form action="adm.php?action=newforum" method="post">
						<p>HTML is allowed in forum descriptions.</p>
						<fieldset>
							<legend>Add new forum</legend>
							<table>
								<tr><td><strong>Name:</strong></td><td><input type="text" name="name"></td></tr>
								<tr><td><strong>Description:</strong></td><td><textarea rows="5" cols="30" name="description"></textarea></td></tr>
								<tr><td>&nbsp;</td><td><input type="submit" value="Create forum"></td></tr>
							</table>
					</fieldset>
					</form>
					<hr>
					<h3>Delete forum</h3>
					<form action="adm.php?action=delforum" method="post">
					<p><strong>Forum:</strong> <select name="forum">
					<?php
					foreach (glob($config["datadir"] . "*") as $cat) {
						$forum_num = $forum_num + 1;
						$title = file_get_contents("$cat/title.txt"); # forum title
						$cat = str_replace($config["datadir"], "", $cat); # get rid of $config["datadir"]'s name
						echo "<option value=\"$cat\">$title</option>\n";
					}	?>
					</select> <input type="submit" value="Delete forum"></p>
					</form>
				<?php
				include($config["themes"] . $config["theme"] . "/footer.html");
			break;

			#----------- logout
			case "newforum":
				if ($_POST["name"] and $_POST["description"])
				{
					$id = file_get_contents("logs/forumid");
					foreach (glob($config["datadir"] . "*") as $unusedvar)
					{
						$id = $id + 1;
					}
					$id = $id + 1;
					$name = htmlentities(stripslashes($_POST["name"]), ENT_QUOTES);
					$description = stripslashes($_POST["description"]);
					mkdir($config["datadir"] .$id);
					file_put_contents($config["datadir"] . "$id/title.txt", $name);
					file_put_contents($config["datadir"] . "$id/pn.txt", "0");
					file_put_contents($config["datadir"] . "$id/last.txt", "None");
					file_put_contents($config["datadir"] . "$id/postnumber.txt", "0");
					file_put_contents($config["datadir"] . "$id/description.txt", $description);
					file_put_contents($config["adminlog"], "<tr><td>" . date($config["date"]) . " " . date($config["time"]) . "</td><td>$tbUsername</td><td>" . $_SERVER["REMOTE_ADDR"] . "</td><td>Added forum <a href=\"category.php?id=$id\">$name</a></td></tr>" . file_get_contents($config["adminlog"]));
					header("Location: adm.php?action=forums");exit;
				}
				else
				{
					$ptitle = "Forums - Administration panel - " . $config["title"];
					include($config["themes"] . $config["theme"] . "/header.html");
					echo "<p class=\"box\"><big><strong>Error:</strong></big> You forgot to fill out a field!</p>";
					include($config["themes"] . $config["theme"] . "/footer.html");
				}
			break;

			#----------- edit forum
			case "editforum":
			if ($_GET["id"] and $_POST["title"] and $_POST["description"])
			{
				$id = htmlentities(stripslashes($_GET["id"]), ENT_QUOTES);
				$name = htmlentities(stripslashes($_POST["title"]), ENT_QUOTES);
				$description = stripslashes($_POST["description"]);
				file_put_contents($config["datadir"] . "$id/title.txt", $name);
				file_put_contents($config["datadir"] . "$id/description.txt", $description);
				file_put_contents($config["adminlog"], "<tr><td>" . date($config["date"]) . " " . date($config["time"]) . "</td><td>$tbUsername</td><td>" . $_SERVER["REMOTE_ADDR"] . "</td><td>Edited forum <a href=\"category.php?id=$id\">$name</a></td></tr>" . file_get_contents($config["adminlog"]));
				header("Location: adm.php?action=forums");exit;
			}
			else
			{
				echo "error";
			}
			break;

			case "delforum":
				if ($_POST["forum"])
				{
					$forum = htmlentities(stripslashes($_POST["forum"]), ENT_QUOTES);
					if (is_dir($config["datadir"] . $forum))
					{
						$name = file_get_contents($config["datadir"] . "$forum/title.txt");
						foreach (glob($config["datadir"] . $forum . "/*") as $file) {
							unlink($file);
						}
						rmdir($config["datadir"] . $forum);
						file_put_contents($config["adminlog"], "<tr><td>" . date($config["date"]) . " " . date($config["time"]) . "</td><td>$tbUsername</td><td>" . $_SERVER["REMOTE_ADDR"] . "</td><td>Removed forum $name</td></tr>" . file_get_contents($config["adminlog"]));
						header("Location: adm.php?action=forums");
						exit;
					}
					else
					{
						$ptitle = "Forums - Administration panel - " . $config["title"];
						include($config["themes"] . $config["theme"] . "/header.html");
						echo "<div class=\"error\"><big><strong>Error:</strong></big> Invalid forum!</p>";
						include($config["themes"] . $config["theme"] . "/footer.html");
					}
				}
				else
				{
					$ptitle = "Forums - Administration panel - " . $config["title"];
					include($config["themes"] . $config["theme"] . "/header.html");
					echo "<p class=\"error\"><big><strong>Error:</strong></big> No forum specified!</p>";
					include($config["themes"] . $config["theme"] . "/footer.html");
				}
				break;

				#----------- view logs
				case "logs":
					$ptitle = "Logs - " . $config["title"];
					include($config["themes"] . $config["theme"] . "/header.html");
					?>
<div class="box">
	<strong>Logs:</strong> <a href="#admin">Admin logs</a> &bull; <a href="#posting">Posting</a> &bull; <strong><a href="adm.php?action=clearlogs">Clear logs</a></strong>
</div>
<h2><a href="adm.php">ADM:</a> Logs</h2>
<h3 id="admin">Admin logs:</h3>
<table class="table forums">
	<tr class="toptr"><td>Date/time</td><td>Username</td><td>IP</td><td>Action</td></tr>
		<?php
			if (filesize($config["adminlog"]) == 0)
			{
				echo "<tr><td colspan=\"5\" class=\"redtext\"><strong>No logs to display.</strong></td></tr>";
			}
			else
			{
				echo file_get_contents($config["adminlog"]);
			}
		?>
</table>
<hr>
<h3 id="posting">Post log:</h3>
<table class="table forums">
	<tr class="toptr"><td>Date/time</td><td>Username</td><td>Subject</td><td>IP</td><td>User Agent</td></tr>
		<?php
			if (filesize($config["postlog"]) == 0)
			{
				echo "<tr><td colspan=\"5\" class=\"redtext\"><strong>No logs to display.</strong></td></tr>";
			}
			else
			{
				echo file_get_contents($config["postlog"]);
			}
		?>
</table>
				<?php
				include($config["themes"] . $config["theme"] . "/footer.html");
				break;
			
				#---- clear logs
				case "clearlogs":
					file_put_contents($config["adminlog"], "");
					file_put_contents($config["postlog"], "");
					header("Location: adm.php?action=logs");exit;
				break;

			#----------- make announcement page
				case "announce":
					$ptitle = "Announcements - " . $config["title"];
					include($config["themes"] . $config["theme"] . "/header.html");
?>
<div class="fright"><strong><a href="adm.php?action=cla">Clear announcements</a></strong></div>
<h2><a href="adm.php">ADM:</a> Forum Announcements</h2>
<h3>Post an announcement:</h3>
<form action="adm.php?action=mkannounce" method="post">
	<p>BBCode and HTML is allowed here.</p>
	<table>
		<tr><td><strong>Subject:</strong></td><td><input type="text" name="subject"></td></tr>
		<tr><td><strong>Content:</strong></td><td><textarea rows="7" cols="40" name="content"></textarea></td></tr>
		<tr><td></td><td><input type="submit" value="Post announcement"></td></tr>
	</table>
</form>
<hr>
<h3>Announcements:</h3>
	<?php
		if (file_exists($config["announcefile"]))
		{
			echo "<table class=\"table post\">";
			echo file_get_contents($config["announcefile"]);
			echo "</table>";
		}
		else
		{
			echo "<div class=\"error\"><strong>Error: Announcement file doesn't exist!</strong></div>";
		}
include($config["themes"] . $config["theme"] . "/footer.html");
				break;
				#===========================================================
				# Post announcement
				case "mkannounce":
					if ($_POST["subject"] and $_POST["content"])
					{
						$subject = htmlentities(stripslashes($_POST["subject"]), ENT_QUOTES);
						$username = $_SESSION["tb_username"];
						$content = stripslashes($_POST["content"]);
						$content = nl2br($content);
						$content = bbcode_format($content);
						$color = file_get_contents($config["userdata"] . "$tbUsername.color");
$poststyle= "<tr class=\"toptr\"><td colspan=\"2\"><strong>$subject</strong></td></tr>
<tr>
<td class=\"info\">
<div><strong><a href=\"profile.php?user=$tbUsername\" style=\"color:$color;\">$username</a></strong></div>
<div><img src=\"avatar.php?username=$username\" alt=\"\"></div>
<div><small>Posted on: " . date($config["date"]) . "</small></div>
</td>
<td>$content</td></tr>\n";

						file_put_contents($config["announcefile"], $poststyle . file_get_contents($config["announcefile"]));
						header("Location: adm.php?action=announce"); exit;
					}
					else
					{
						header("Location: adm.php?action=announce"); exit;
					}
				break;
				#----------- clear announcements
				case "cla":
					file_put_contents($config["announcefile"], "");
					header("Location: adm.php?action=announce"); exit;
				break;

				#----------- post locking (not exactly part of the admin panel)
				case "lock":
					if (isset($_GET["cat"]) and isset($_GET["pid"])) {
						$cat = htmlentities(stripslashes($_GET["cat"]), ENT_QUOTES);
						$pid = htmlentities(stripslashes($_GET["pid"]), ENT_QUOTES);
						if (file_exists($config["datadir"] . "$cat/$pid.lock")) {
							# unlock
							unlink($config["datadir"] . "$cat/$pid.lock");
							header("Location: view.php?cat=$cat&pid=$pid"); exit;
						}
						else
						{
							# lock
							file_put_contents($config["datadir"] . "$cat/$pid.lock","");
							header("Location: view.php?cat=$cat&pid=$pid"); exit;
						}
					}
					else
					{
						# no needed vars.
						header("Location: adm.php"); exit;
					}
				break;


				#------------- delete topic
				case "deltopic":
					if (isset($_GET["cat"]) and isset($_GET["pid"])) {
						$cat = htmlentities(stripslashes($_GET["cat"]), ENT_QUOTES);
						$pid = htmlentities(stripslashes($_GET["pid"]), ENT_QUOTES);
						if (file_exists($config["datadir"] . $cat . "/$pid.html")) {
							array_map( "unlink", glob($config["datadir"] . $cat . "/$pid" . "*") );
							$ptitle = "post deleted"; include($config["themes"] . $config["theme"] . "/header.html");
							echo "<div class=\"box\">Post deleted! <a href=\"index.php\">Index page</a></div>";
							include($config["themes"] . $config["theme"] . "/footer.html");
						}
						else
						{
							$ptitle = "Error"; include($config["themes"] . $config["theme"] . "/header.html");
							echo "<div class=\"error\">Post doesn't exist! <a href=\"index.php\">Index page</a></div>";
							include($config["themes"] . $config["theme"] . "/footer.html");
						}
					}
					else
					{
						$ptitle = "Error"; include($config["themes"] . $config["theme"] . "/header.html");
						echo "<div class=\"error\">No data specified. <a href=\"index.php\">Index page</a></div>";
						include($config["themes"] . $config["theme"] . "/footer.html");
					}
				break;
			
				#--------- info box form
				case "infobox":
						$ptitle = "Infobox - " . $config["title"];
						include($config["themes"] . $config["theme"] . "/header.html");
						?>
<h2><a href="adm.php">ADM:</a> Information box</h2>
<p>The information box is shown at the top-right part of the screen. It shows various notices and other content that you put in below. You can use HTML only on this.</p>
<form action="adm.php?action=sinfobox" method="post">
	<p><textarea rows="9" cols="50" name="infotext"><?php echo file_get_contents($config["infofile"]); ?></textarea></p>
	<p><input type="submit" value="Save"></p>
</form>
						<?php
						include($config["themes"] . $config["theme"] . "/footer.html");
				break;
				
				#----------- save information box
				case "sinfobox":
					if (isset($_POST["infotext"])) {
						$infotext = stripslashes($_POST["infotext"]);
						file_put_contents($config["infofile"], $infotext);
						$ptitle = $config["title"]; include($config["themes"] . $config["theme"] . "/header.html");
						echo "<meta http-equiv=\"refresh\" content=\"3; url=adm.php?action=infobox\">";
						echo "<div class=\"box\">Infobox saved! If your browser doesn't redirect you, <a href=\"adm.php?action=infobox\">click here</a>.</div>";
						include($config["themes"] . $config["theme"] . "/footer.html");
					}
					else
					{
						header("Location: adm.php?action=infobox"); exit;
					}
				break;
				
				# make user admin
				case "mkadmin":
					$ptitle = "admin - " . $config["title"];
					include($config["themes"] . $config["theme"] . "/header.html");
					if (isset($_POST["username"])) {
						$username = htmlentities(stripslashes($_POST["username"]), ENT_QUOTES);
						if (file_exists($config["userdata"] . "/$username.php")) {
							file_put_contents($config["userdata"] . "/$username.admin", "");
							file_put_contents($config["adminlog"], "<tr><td>" . date($config["date"]) . " " . date($config["time"]) . "</td><td>$tbUsername</td><td>" . $_SERVER["REMOTE_ADDR"] . "</td><td>Added administrator status to <a href=\"profile.php?user=$username\">$username</a></td></tr>" . file_get_contents($config["adminlog"]));
							echo "<meta http-equiv=\"refresh\" content=\"3; url=adm.php?action=mkadmin\">";
							echo "<div class=\"box\"><strong>$username</strong> is now an admin. If your browser doesn't redirect you, <a href=\"adm.php?action=mkadmin\">click here</a></div>";
						}
						else
						{
							echo "<div class=\"error\">The username specified does not exist. <a href=\"adm.php?action=mkadmin\">Go back</a></div>";
						}
					}
					else
					{
					?>
<h2><a href="adm.php">ADM:</a> Administrate user</h2>
<form action="adm.php?action=mkadmin" method="post">
	<p>Username: <input type="text" name="username"> <input type="submit" value="Go"></p>
</form>
					<?php
					}
					include($config["themes"] . $config["theme"] . "/footer.html");
				break;
				
				
				# remove admin from user
				case "rmadmin":
					$ptitle = "admin - " . $config["title"];
					include($config["themes"] . $config["theme"] . "/header.html");
					if (isset($_POST["username"])) {
						$username = htmlentities(stripslashes($_POST["username"]), ENT_QUOTES);
						if (file_exists($config["userdata"] . "/$username.php")) {
							unlink($config["userdata"] . "/$username.admin");
							file_put_contents($config["adminlog"], "<tr><td>" . date($config["date"]) . " " . date($config["time"]) . "</td><td>$tbUsername</td><td>" . $_SERVER["REMOTE_ADDR"] . "</td><td>Removed administrator status from <a href=\"profile.php?user=$username\">$username</a></td></tr>" . file_get_contents($config["adminlog"]));
							echo "<meta http-equiv=\"refresh\" content=\"3; url=adm.php?action=rmadmin\">";
							echo "<div class=\"box\"><strong>$username</strong> is no longer an admin. If your browser doesn't redirect you, <a href=\"adm.php?action=rmadmin\">click here</a></div>";
						}
						else
						{
							echo "<div class=\"error\">The username specified does not exist. <a href=\"adm.php?action=mkadmin\">Go back</a></div>";
						}
					}
					else
					{
					?>
<h2><a href="adm.php">ADM:</a> Unadministrate user</h2>
<form action="adm.php?action=rmadmin" method="post">
	<p>Username: <input type="text" name="username"> <input type="submit" value="Go"></p>
</form>
					<?php
					}
					include($config["themes"] . $config["theme"] . "/footer.html");
				break;
				
				
				#----------- change user rank
				case "chrank":
					$ptitle = "Ranks - " . $config["title"];
					include($config["themes"] . $config["theme"] . "/header.html");
					if (isset($_POST["username"]) and isset($_POST["rank"])) {
						$username = htmlentities(stripslashes($_POST["username"]), ENT_QUOTES);
						$rank = htmlentities(stripslashes($_POST["rank"]), ENT_QUOTES);
						if (file_exists($config["userdata"] . "/$username.php")) {
							file_put_contents($config["userdata"] . "/$username.rank", $rank);
							echo "<meta http-equiv=\"refresh\" content=\"3; url=adm.php?action=chrank\">";
							echo "<div class=\"box\">Changed $username's rank to <strong>$rank</strong>. If your browser doesn't redirect you, <a href=\"adm.php?action=chrank\">click here</a></div>";
						}
						else
						{
							echo "<div class=\"error\">The username specified does not exist. <a href=\"adm.php?action=mkadmin\">Go back</a></div>";
						}
					}
					else
					{
						?>
<h2><a href="adm.php">ADM:</a> Change rank</h2>
<form action="adm.php?action=chrank" method="post">
	<p>Username: <input type="text" name="username"></p>
	<p>Rank: <input type="text" name="rank"> <input type="submit" value="Go"></p>
</form>
						<?php
						include($config["themes"] . $config["theme"] . "/footer.html");
					}
				break;

				#----------- change user color
				case "chcolor":
					$ptitle = "Ranks - " . $config["title"];
					include($config["themes"] . $config["theme"] . "/header.html");
					if (isset($_POST["username"]) and isset($_POST["color"])) {
						$username = htmlentities(stripslashes($_POST["username"]), ENT_QUOTES);
						$color = htmlentities(stripslashes($_POST["color"]), ENT_QUOTES);
						if (file_exists($config["userdata"] . "/$username.php")) {
							file_put_contents($config["userdata"] . "/$username.color", $color);
							echo "<meta http-equiv=\"refresh\" content=\"3; url=adm.php?action=chcolor\">";
							echo "<div class=\"box\">Changed $username's color to <strong style=\"color:$color;\">$color</strong>. If your browser doesn't redirect you, <a href=\"adm.php?action=chcolor\">click here</a></div>";
						}
						else
						{
							echo "<div class=\"error\">The username specified does not exist. <a href=\"adm.php?action=mkadmin\">Go back</a></div>";
						}
					}
					else
					{
						?>
<h2><a href="adm.php">ADM:</a> Change color</h2>
<form action="adm.php?action=chcolor" method="post">
	<p>Username: <input type="text" name="username"></p>
	<p>Color: <input type="text" name="color"> <input type="submit" value="Go"></p>
</form>
						<?php
						include($config["themes"] . $config["theme"] . "/footer.html");
					}
				break;

				#----------- default
				default:
					$ptitle = "Administration panel - " . $config["title"];
					include($config["themes"] . $config["theme"] . "/header.html");
					echo "<div class=\"error\"><strong>Error:</strong> Invalid admin page!</div>";
					include($config["themes"] . $config["theme"] . "/footer.html");
				break;
			}
		
		}
		else
		{
			# Password is incorrect.
			session_destroy();
			header("Location: login.php"); exit;
		}
	}
	else
	{
		# User doesn't exist.
		session_destroy();
		header("Location: register.php"); exit;
	}
}
else
{
	# User is not logged in.
	header("Location: login.php"); exit;
}
?>
