<?php
/*
TuxBoard forum script
Copyright (C) 2013  Colin Murphy

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

session_start();
require_once("config.php");

# check if user is logged in
if ($_SESSION["tb_username"] and $_SESSION["tb_password"]) {
	if (file_exists($config["userdata"] . $_SESSION["tb_username"] . ".php")) {
		# User exists. Check if password is correct.
		include($config["userdata"] . $_SESSION["tb_username"] . ".php");
		if ($tbPassword == htmlentities(stripslashes($_SESSION["tb_password"]), ENT_QUOTES)) {
			$loggedin = true;
		}
	}
}

if (isset($_GET["user"])) {
	$user = htmlentities(stripslashes($_GET["user"]), ENT_QUOTES);
	$ptitle = "$user's profile - " . $config["title"];
	include($config["themes"] . $config["theme"] . "/header.html");
	if (file_exists($config["userdata"] . "$user.php")) {
		$postcount = 3;
		$topiccount = 1;
		$website = file_get_contents($config["userdata"] . "$user.web");
		$age = file_get_contents($config["userdata"] . "$user.age");
		$color = file_get_contents($config["userdata"] . "$user.color");
		$rank = file_get_contents($config["userdata"] . "$user.rank");
		$posts = file_get_contents($config["userdata"] . "$user.posts");
		$topics = file_get_contents($config["userdata"] . "$user.topics");
		
		# clean website url
		$website_edited = str_replace(array("http://","https://"), "", $website);
		
		# check if stuff is even specified.
		if (!$age){$age = "n/a";}
		if ($website_edited){
			$website = "<a href=\"$website\">$website_edited</a>";
		}
		else
		{
			$website = "n/a";
		}
		
		# check if $user is also $tbUsername
		if ($user == $tbUsername) { $editprofile = "<p><strong><a href=\"ucp.php?action=profile\">Edit your profile</a></strong></p>"; } else {$editprofile = ""; }
		?>
<h1><span style="color: <?php echo $color; ?>"><?php echo $user; ?></span>'s profile</h1>
<?php echo $editprofile; ?>
<table class="table forums">
	<tr class="toptr"><td>Avatar</td><td>Information</td></tr>
	<tr>
		<td class="info">
			<p><img src="avatar.php?username=<?php echo $user; ?>" alt=""></p>
		</td>
		<td class="topalign">
			<table class="noborder">
<?php
# Profile infos
echo "<tr><td><strong>Topics:</strong></td><td>$topics</td></tr>";
echo "<tr><td><strong>Posts:</strong></td><td>$posts</td></tr>";
echo "<tr><td><strong>Rank:</strong></td><td>$rank</td></tr>";
echo "<tr><td><strong>Age:</strong></td><td>$age</td></tr>";
if ($loggedin == true) { echo "<tr><td><strong>Website:</strong></td><td>$website</tr>"; }

?>
			</table>
		</td>
	</tr>
</table>
		<?php
	}
	else
	{
		echo "<div class=\"error\"><strong>Error:</strong> Username $user does not exist!</div>";
	}
}
else
{
	echo "<div class=\"error\"><strong>Error:</strong> No username specified!</div>";
}

include($config["themes"] . $config["theme"] . "/footer.html");
?>
