<?php
/*
TuxBoard forum script
Copyright (C) 2013  Colin Murphy

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

session_start();
require_once("config.php");
require_once("bbcode.php");

if (isset($_SESSION["tb_username"]) and isset($_SESSION["tb_password"])) {
	if (file_exists($config["userdata"] . $_SESSION["tb_username"] . ".php")) {
		# User exists. Check if password is correct.
		include($config["userdata"] . $_SESSION["tb_username"] . ".php");
		if ($tbPassword == htmlentities(stripslashes($_SESSION["tb_password"]))) {
			# Password is correct.
			$loggedin = true;
		}
		else
		{
			# Incorrect password... destroy the session and go to the login form.
			header("Location: login.php"); exit;
		}
	}
	else
	{
		# User doesn't exist... destroy the session and go to the login form.
		header("Location: login.php");exit;
	}
}
else
{
	# User is not logged in.
	$loggedin = false;
}

if (isset($_GET["cat"]) and isset($_GET["pid"]) and $loggedin == true)
{
	$cat = htmlentities(stripslashes($_GET["cat"]), ENT_QUOTES);
	$pid = htmlentities(stripslashes($_GET["pid"]), ENT_QUOTES);
}
else
{
	header("Location: index.php");
	exit;
}

# check if locked
if (file_exists($config["datadir"] . "$cat/$pid.lock")) {
	$ptitle = "Reply - " . $config["title"];
	include($config["themes"] . $config["theme"] . "/header.html");
	echo "<div class=\"error\">This topic is locked. <a href=\"view.php?cat=$cat&amp;pid=$pid\">Go back</a></div>";
	include($config["themes"] . $config["theme"] . "/footer.html");
	die(); # kill the script.
}

# Check if user is an admin
if (file_exists($config["userdata"] . $_SESSION["tb_username"] . ".admin")) {
	$admin = true;
}

if ($_POST["content"])
{
	$username = htmlentities(stripslashes($_SESSION["tb_username"]), ENT_QUOTES);
	$content = htmlentities(stripslashes($_POST["content"]), ENT_QUOTES);
	$lock = htmlentities(stripslashes($_POST["lock"]), ENT_QUOTES);
	$content = nl2br($content);
	$content = bbcode_format($content);
	
	$usercolor = file_get_contents($config["userdata"] . "$username.color");
	$userrank = file_get_contents($config["userdata"] . "$username.rank");
	
	$username = "<span style=\"color: $usercolor\">$username</span>";
	
		$poststyle= "<tr>
	<td class=\"info\" id=\"p$cat$pid\">
	<div><strong><a href=\"profile.php?user=$tbUsername\" style=\"color:$usercolor;\">$tbUsername</a></strong></div>
	<div>$userrank</div>
	<img src=\"avatar.php?username=$tbUsername\" alt=\"\">
	<div><small>Posted on: " . date($config["date"]) . " " . date($config["time"]) . "</small></div>
	</td>
	<td>$content</td>
</tr>";

	# Get post subject
	if (file_exists($config["datadir"] . $cat . "/$pid" . "_subject.txt")) # Check if subject file exists
	{
		$subject = file_get_contents($config["datadir"] . $cat . "/$pid" . "_subject.txt"); # Subject file exists.
	}
	else
	{
		$subject = $pid; # Subject file doesnt exist
	}
	
	# Incremental post #
	$spid = file_get_contents($config["datadir"] . $cat . "/postnumber.txt");
	$setpid = $spid + 1;
	file_put_contents($config["datadir"] . $cat . "/postnumber.txt", $setpid);
	
	# incremental post for reply count
	$rspid = file_get_contents($config["datadir"] . $cat . "$pid.replies");
	$rsetpid = $rspid + 1;
	file_put_contents($config["datadir"] . $cat . "/$pid.replies", $rsetpid);

	file_put_contents($config["userdata"] . "$username.posts", file_get_contents($config["userdata"] . "$username.posts") + 1);
	
	# lock post if instructed to...
	if ($admin == true and $lock == true){
		file_put_contents($config["datadir"] . $cat . "/$pid.lock", "");
	}

#===============================

	# Logging
	file_put_contents($config["postlog"], "<tr><td>" . date($config["date"]) . " " . date($config["time"]) . "</td><td>$username</td><td>re:<a href=\"view.php?cat=$cat&amp;pid=$pid\">$subject</a></td><td>" . $_SERVER["REMOTE_ADDR"] . "</td><td>" . htmlentities($_SERVER["HTTP_USER_AGENT"], ENT_QUOTES) . "</td></tr>\n" . file_get_contents($config["postlog"]));
	# END LOGGING

	$old = file_get_contents($config["datadir"] . $cat . "/$pid.html");
	file_put_contents($config["datadir"] . $cat . "/$pid.html", $old . $poststyle);
	file_put_contents($config["datadir"] . $cat . "/last.txt", "<a href=\"view.php?cat=$cat&amp;pid=$pid\">$subject</a> by $username"); # Set last message
	header("Location: view.php?cat=$cat&pid=$pid");exit;
}
else
{
	$ptitle = "Reply - " . $config["title"];
	include($config["themes"] . $config["theme"] . "/header.html");
?>
<h2>Reply to <a href="view.php?cat=<?php echo $cat; ?>&amp;pid=<?php echo $pid; ?>"><?php echo file_get_contents($config["datadir"] . $cat . "/$pid" . "_subject.txt"); ?></a></h2>
<form action="reply.php?cat=<?php echo $cat; ?>&amp;pid=<?php echo $pid; ?>" method="post">
	<table>
		<tr><td></td><td><input type="button" onclick="add('[b][/b]');" value="b"> <input type="button" onclick="add('[i][/i]');" value="i"> <input type="button" onclick="add('[u][/u]');" value="u"> <input type="button" onclick="add('[img][/img]');" value="img"> <input type="button" onclick="add('[code][/code]');" value="code"> </td></tr>
		<tr><td><strong>Post:</strong></td><td><textarea rows="10" cols="50" name="content" id="content"></textarea></td></tr>
		<?php if ($admin == true) {
			echo "<tr><td><strong>Lock topic</strong></td><td><input type=\"checkbox\" value=\"true\" name=\"lock\"></td></tr>";
		}?>
		<tr><td>&nbsp;</td><td><input type="submit" value="Send Reply"></td></tr>
	</table>
</form>
<?php
	include($config["themes"] . $config["theme"] . "/footer.html");
}
?>
